COMMENT \
/* { Adapted from ASCII.H }
*
* This parameter definition file defines the ASCII character set.  The
* standard mnemonics are used for characters 0..31, and they are  also
* given alternate names CTLx.  Special characters are assigned obvious
* abbreviations.  Digits are  DIGITn, upper-case  letters LETUC*,  and
* lower-case letters LETLC*.   To ensure  uniqueness, all are prefixed
* by a period (a la TOPS-20 usage)
*/
\
.NUL    EQU     000Q
.SOH    EQU     001Q
.STX    EQU     002Q
.ETX    EQU     003Q
.EOT    EQU     004Q
.ENQ    EQU     005Q
.ACK    EQU     006Q
.BEL    EQU     007Q
.BS     EQU     010Q
.HT     EQU     011Q
.LF     EQU     012Q
.NL     EQU     012Q
.VT     EQU     013Q
.FF     EQU     014Q
.CR     EQU     015Q
.SO     EQU     016Q
.SI     EQU     017Q
.DLE    EQU     020Q
.DC1    EQU     021Q
.DC2    EQU     022Q
.DC3    EQU     023Q
.DC4    EQU     024Q
.NAK    EQU     025Q
.SYN    EQU     026Q
.ETB    EQU     027Q
.CAN    EQU     030Q
.EM     EQU     031Q
.SUB    EQU     032Q
.ESC    EQU     033Q
.FS     EQU     034Q
.GS     EQU     035Q
.RS     EQU     036Q
.US     EQU     037Q
.CTLA   EQU     001Q
.CTLB   EQU     002Q
.CTLC   EQU     003Q
.CTLD   EQU     004Q
.CTLE   EQU     005Q
.CTLF   EQU     006Q
.CTLG   EQU     007Q
.CTLH   EQU     010Q
.CTLI   EQU     011Q
.CTLJ   EQU     012Q
.CTLK   EQU     013Q
.CTLL   EQU     014Q
.CTLM   EQU     015Q
.CTLN   EQU     016Q
.CTLO   EQU     017Q
.CTLP   EQU     020Q
.CTLQ   EQU     021Q
.CTLR   EQU     022Q
.CTLS   EQU     023Q
.CTLT   EQU     024Q
.CTLU   EQU     025Q
.CTLV   EQU     026Q
.CTLW   EQU     027Q
.CTLX   EQU     030Q
.CTLY   EQU     031Q
.CTLZ   EQU     032Q
.CTLLBR  EQU    033Q
.CTLBSL  EQU    034Q
.CTLRBR  EQU    035Q
.CTLCAR  EQU    036Q
.CTLUSC  EQU    037Q
.BLANK  EQU     040Q
.BANG   EQU     041Q
.DQUOTE  EQU    042Q
.HASH   EQU     043Q
.DOLLAR  EQU    044Q
.PERCNT  EQU    045Q
.AMPSND  EQU    046Q
.SQUOTE  EQU    047Q
.LPAREN  EQU    050Q
.RPAREN  EQU    051Q
.STAR   EQU     052Q
.PLUS   EQU     053Q
.COMMA  EQU     054Q
.MINUS  EQU     055Q
.PERIOD  EQU    056Q
.SLASH  EQU     057Q
.DIGIT0  EQU    060Q
.DIGIT1  EQU    061Q
.DIGIT2  EQU    062Q
.DIGIT3  EQU    063Q
.DIGIT4  EQU    064Q
.DIGIT5  EQU    065Q
.DIGIT6  EQU    066Q
.DIGIT7  EQU    067Q
.DIGIT8  EQU    070Q
.DIGIT9  EQU    071Q
.COLON  EQU     072Q
.SEMI   EQU     073Q
.LANGLE  EQU    074Q
.EQUALS  EQU    075Q
.RANGLE  EQU    076Q
.QUERY  EQU     077Q
.ATSIGN  EQU    100Q
.LETUCA  EQU    101Q
.LETUCB  EQU    102Q
.LETUCC  EQU    103Q
.LETUCD  EQU    104Q
.LETUCE  EQU    105Q
.LETUCF  EQU    106Q
.LETUCG  EQU    107Q
.LETUCH  EQU    110Q
.LETUCI  EQU    111Q
.LETUCJ  EQU    112Q
.LETUCK  EQU    113Q
.LETUCL  EQU    114Q
.LETUCM  EQU    115Q
.LETUCN  EQU    116Q
.LETUCO  EQU    117Q
.LETUCP  EQU    120Q
.LETUCQ  EQU    121Q
.LETUCR  EQU    122Q
.LETUCS  EQU    123Q
.LETUCT  EQU    124Q
.LETUCU  EQU    125Q
.LETUCV  EQU    126Q
.LETUCW  EQU    127Q
.LETUCX  EQU    130Q
.LETUCY  EQU    131Q
.LETUCZ  EQU    132Q
.LBRACK  EQU    133Q
.BSLASH  EQU    134Q
.RBRACK  EQU    135Q
.CARET  EQU     136Q
.USCORE  EQU    137Q
.GRAVE  EQU     140Q
.LETLCa  EQU    141Q
.LETLCb  EQU    142Q
.LETLCc  EQU    143Q
.LETLCd  EQU    144Q
.LETLCe  EQU    145Q
.LETLCf  EQU    146Q
.LETLCg  EQU    147Q
.LETLCh  EQU    150Q
.LETLCi  EQU    151Q
.LETLCj  EQU    152Q
.LETLCk  EQU    153Q
.LETLCl  EQU    154Q
.LETLCm  EQU    155Q
.LETLCn  EQU    156Q
.LETLCo  EQU    157Q
.LETLCp  EQU    160Q
.LETLCq  EQU    161Q
.LETLCr  EQU    162Q
.LETLCs  EQU    163Q
.LETLCt  EQU    164Q
.LETLCu  EQU    165Q
.LETLCv  EQU    166Q
.LETLCw  EQU    167Q
.LETLCx  EQU    170Q
.LETLCy  EQU    171Q
.LETLCz  EQU    172Q
.LBRACE  EQU    173Q
.VBAR   EQU     174Q
.RBRACE  EQU    175Q
.TILDE  EQU     176Q
.DEL    EQU     177Q
